package com.objis.tp.filtrejee.filtre;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;

import com.objis.tp.filtrejee.util.CharResponseWrapper;
import com.objis.tp.filtrejee.util.Compteur;

public final class FiltreCompteurVisites implements Filter {
    private FilterConfig filterConfig = null;

    public void init(FilterConfig filterConfig) throws ServletException {
        this.filterConfig = filterConfig;
    }
    
    public void destroy() {
        this.filterConfig = null;
    }
 
    public void doFilter(ServletRequest request, ServletResponse response,
      FilterChain chain) throws IOException, ServletException {

      if (filterConfig == null)
        return;

      StringWriter sw = new StringWriter();
      PrintWriter writer = new PrintWriter(sw);

      Compteur Compteur = (Compteur)filterConfig.getServletContext().getAttribute("compteurNbVisites");
      writer.println();
      writer.println("=======================================================");
      writer.println("Nombre de visiteurs : " + Compteur.incCounter());
      writer.println("=======================================================");

      // Log the resulting string
      writer.flush();
      filterConfig.getServletContext().log(sw.getBuffer().toString());

      PrintWriter out = response.getWriter();
      CharResponseWrapper wrapper = new CharResponseWrapper((HttpServletResponse)response); 
      chain.doFilter(request, wrapper);
      CharArrayWriter caw = new CharArrayWriter();
      caw.write(wrapper.toString().substring(0, wrapper.toString().indexOf("</body>")-1));
      caw.write("<p>\n<center>" + "Vous tes le visiteur n " + "<font color='red'>" + Compteur.getCounter() + "</font></center>");
      caw.write("\n</body></html>");
      response.setContentLength(caw.toString().length());
      out.write(caw.toString());        
      out.close();
    }

    public String toString() {
      if (filterConfig == null)  
        return ("HitCompteurFilter()");
      StringBuffer sb = new StringBuffer("HitCompteurFilter(");
      sb.append(filterConfig);
      sb.append(")");
      return (sb.toString());
    }
}

